unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBClient, Grids, DBGrids, ExtCtrls, DBCtrls, StdCtrls,
  Provider;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    ClientDataSet1: TClientDataSet;
    ClientDataSet1Key: TIntegerField;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Edit1: TEdit;
    Button1: TButton;
    DataSetProvider1: TDataSetProvider;
    ClientDataSet2: TClientDataSet;
    ClientDataSet3: TClientDataSet;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DataSetProvider1BeforeUpdateRecord(Sender: TObject;
      SourceDS: TDataSet; DeltaDS: TCustomClientDataSet;
      UpdateKind: TUpdateKind; var Applied: Boolean);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    Edit1.Clear;
    with ClientDataSet1 do begin
        CreateDataSet;
        ClientDataSet3.Data := Data;
        Append;
        Fields[0].AsInteger := 0;
        Append;
        Fields[0].AsInteger := 1;
        Append;
        Fields[0].AsInteger := 2;
        Post;
        First;
    end;
    ClientDataSet2.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    ClientDataSet3.EmptyDataSet;
    ClientDataSet2.ApplyUpdates(StrToIntDef(Edit1.Text,0));
end;

procedure TForm1.DataSetProvider1BeforeUpdateRecord(Sender: TObject;
  SourceDS: TDataSet; DeltaDS: TCustomClientDataSet;
  UpdateKind: TUpdateKind; var Applied: Boolean);
begin
    if DeltaDS.Fields[0].OldValue mod 2 = 0 then begin
        Applied := True;
        ClientDataSet3.Append;
        ClientDataSet3.Fields[0].AsInteger := DeltaDS.Fields[0].OldValue; end
    else
        raise Exception.Create('error');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    ClientDataSet2.CancelUpdates;
end;

end.
